#ifndef _CL_ERROR_TABLE_H_
#define _CL_ERROR_TABLE_H_

#ifndef _CL_ERROR_TABLE_
#error "This file can only be included from clErrorTable.c"
#endif

#define CL_COMP_SPECIFIC_ERROR_CODE_START       (CL_ERR_COMMON_MAX+1)
#define CL_STRING_REP_OF(value)                 #value
#define CL_INVALID_ERROR_CODE                   "No error-to-string mapping in the table, yet."

typedef struct {
    const ClCharT *pCompId;
    const ClCharT **ppCompErrs;
} ClCompErrorT;

static const ClCharT *gpSafErrs[] = {
    CL_STRING_REP_OF(CL_OK),
    CL_STRING_REP_OF(SA_AIS_OK),
    CL_STRING_REP_OF(SA_AIS_ERR_LIBRARY),
    CL_STRING_REP_OF(SA_AIS_ERR_VERSION),
    CL_STRING_REP_OF(SA_AIS_ERR_INIT),
    CL_STRING_REP_OF(SA_AIS_ERR_TIMEOUT),
    CL_STRING_REP_OF(SA_AIS_ERR_TRY_AGAIN),
    CL_STRING_REP_OF(SA_AIS_ERR_INVALID_PARAM),
    CL_STRING_REP_OF(SA_AIS_ERR_NO_MEMORY),
    CL_STRING_REP_OF(SA_AIS_ERR_BAD_HANDLE),
    CL_STRING_REP_OF(SA_AIS_ERR_BUSY),
    CL_STRING_REP_OF(SA_AIS_ERR_ACCESS),
    CL_STRING_REP_OF(SA_AIS_ERR_NOT_EXIST),
    CL_STRING_REP_OF(SA_AIS_ERR_NAME_TOO_LONG),
    CL_STRING_REP_OF(SA_AIS_ERR_EXIST),
    CL_STRING_REP_OF(SA_AIS_ERR_NO_SPACE),
    CL_STRING_REP_OF(SA_AIS_ERR_INTERRUPT),
    CL_STRING_REP_OF(SA_AIS_ERR_NAME_NOT_FOUND),
    CL_STRING_REP_OF(SA_AIS_ERR_NO_RESOURCES),
    CL_STRING_REP_OF(SA_AIS_ERR_NOT_SUPPORTED),
    CL_STRING_REP_OF(SA_AIS_ERR_BAD_OPERATION),
    CL_STRING_REP_OF(SA_AIS_ERR_FAILED_OPERATION),
    CL_STRING_REP_OF(SA_AIS_ERR_MESSAGE_ERROR),
    CL_STRING_REP_OF(SA_AIS_ERR_QUEUE_FULL),
    CL_STRING_REP_OF(SA_AIS_ERR_QUEUE_NOT_AVAILABLE),
    CL_STRING_REP_OF(SA_AIS_ERR_BAD_FLAGS),
    CL_STRING_REP_OF(SA_AIS_ERR_TOO_BIG),
    CL_STRING_REP_OF(SA_AIS_ERR_NO_SECTIONS)
};


static const ClCharT *gpClCommonErrs[] = {
    CL_STRING_REP_OF(CL_OK),
    CL_STRING_REP_OF(CL_ERR_NO_MEMORY),
    CL_STRING_REP_OF(CL_ERR_INVALID_PARAMETER),
    CL_STRING_REP_OF(CL_ERR_NULL_POINTER),
    CL_STRING_REP_OF(CL_ERR_NOT_EXIST),
    CL_STRING_REP_OF(CL_ERR_INVALID_HANDLE),
    CL_STRING_REP_OF(CL_ERR_INVALID_BUFFER), 
    CL_STRING_REP_OF(CL_ERR_NOT_IMPLEMENTED),
    CL_STRING_REP_OF(CL_ERR_DUPLICATE),
    CL_STRING_REP_OF(CL_ERR_QUEUE_NOT_AVAILABLE),
    CL_STRING_REP_OF(CL_ERR_OUT_OF_RANGE),
    CL_STRING_REP_OF(CL_ERR_NO_RESOURCE),
    CL_STRING_REP_OF(CL_ERR_INITIALIZED),
    CL_STRING_REP_OF(CL_ERR_BUFFER_OVERRUN),
    CL_STRING_REP_OF(CL_ERR_NOT_INITIALIZED),
    CL_STRING_REP_OF(CL_ERR_VERSION_MISMATCH),
    CL_STRING_REP_OF(CL_ERR_ALREADY_EXIST),
    CL_STRING_REP_OF(CL_ERR_UNSPECIFIED),
    CL_STRING_REP_OF(CL_ERR_INVALID_STATE),
    CL_STRING_REP_OF(CL_ERR_DOESNT_EXIST),
    CL_STRING_REP_OF(CL_ERR_TIMEOUT),
    CL_STRING_REP_OF(CL_ERR_INUSE),
    CL_STRING_REP_OF(CL_ERR_TRY_AGAIN),
    CL_STRING_REP_OF(CL_ERR_NO_CALLBACK),
    CL_STRING_REP_OF(CL_ERR_MUTEX_ERROR),
    CL_STRING_REP_OF(CL_ERR_NO_OP),
    CL_STRING_REP_OF(CL_ERR_NAME_TOO_LONG),
    CL_STRING_REP_OF(CL_ERR_NAME_NOT_FOUND),
    CL_STRING_REP_OF(CL_ERR_MESSAGE_ERROR),
    CL_STRING_REP_OF(CL_ERR_TOO_BIG),
    CL_STRING_REP_OF(CL_ERR_NO_SECTIONS),
    CL_STRING_REP_OF(CL_ERR_FAILED_OPERATION),
    CL_STRING_REP_OF(CL_ERR_OP_NOT_PERMITTED),
    CL_STRING_REP_OF(CL_ERR_NO_SPACE),
    CL_STRING_REP_OF(CL_ERR_BAD_FLAG),
    CL_STRING_REP_OF(CL_ERR_BAD_OPERATION),
    CL_STRING_REP_OF(CL_ERR_LIBRARY),
    CL_STRING_REP_OF(CL_ERR_NOT_SUPPORTED),
    CL_STRING_REP_OF(CL_ERR_INTERRUPT),
};


static ClCompErrorT gClCompErrs[] = {
    {CL_STRING_REP_OF(CL_CID_UNSPECIFIED), NULL},
    {CL_STRING_REP_OF(CL_CID_OSAL), NULL},
    {CL_STRING_REP_OF(CL_CID_HAL), NULL},
    {CL_STRING_REP_OF(CL_CID_DBAL), NULL},
    {CL_STRING_REP_OF(CL_CID_EO), NULL},
    {CL_STRING_REP_OF(CL_CID_IOC), NULL},
    {CL_STRING_REP_OF(CL_CID_RMD), NULL},
    {CL_STRING_REP_OF(CL_CID_NAMES), NULL},
    {CL_STRING_REP_OF(CL_CID_TIMER), NULL},
    {CL_STRING_REP_OF(CL_CID_SHM), NULL},
    {CL_STRING_REP_OF(CL_CID_DSHM), NULL},
    {CL_STRING_REP_OF(CL_CID_LOG), NULL},
    {CL_STRING_REP_OF(CL_CID_MSG), NULL},
    {CL_STRING_REP_OF(CL_CID_DIAG), NULL},
    {CL_STRING_REP_OF(CL_CID_DEBUG), NULL},
    {CL_STRING_REP_OF(CL_CID_CPM), NULL},
    {CL_STRING_REP_OF(CL_CID_CAP), NULL},
    {CL_STRING_REP_OF(CL_CID_RES), NULL},
    {CL_STRING_REP_OF(CL_CID_GMS), NULL},
    {CL_STRING_REP_OF(CL_CID_EVENTS), NULL},
    {CL_STRING_REP_OF(CL_CID_DLOCK), NULL},
    {CL_STRING_REP_OF(CL_CID_TXN), NULL},
    {CL_STRING_REP_OF(CL_CID_CKPT), NULL},
    {CL_STRING_REP_OF(CL_CID_COR), NULL},
    {CL_STRING_REP_OF(CL_CID_CNT), NULL},
    {CL_STRING_REP_OF(CL_CID_DCNT), NULL},
    {CL_STRING_REP_OF(CL_CID_RCNT), NULL},
    {CL_STRING_REP_OF(CL_CID_ALARMS), NULL},
    {CL_STRING_REP_OF(CL_CID_POLICY), NULL},
    {CL_STRING_REP_OF(CL_CID_RULE), NULL},
    {CL_STRING_REP_OF(CL_CID_SCRIPTING), NULL},
    {CL_STRING_REP_OF(CL_CID_CM), NULL},
    {CL_STRING_REP_OF(CL_CID_HPI), NULL},
    {CL_STRING_REP_OF(CL_CID_FAULTS), NULL},
    {CL_STRING_REP_OF(CL_CID_AMS), NULL},
    {CL_STRING_REP_OF(CL_CID_MED), NULL},
    {CL_STRING_REP_OF(CL_CID_BUFFER), NULL},
    {CL_STRING_REP_OF(CL_CID_QUEUE), NULL},
    {CL_STRING_REP_OF(CL_CID_CLIST), NULL},
    {CL_STRING_REP_OF(CL_CID_SNMP), NULL},
    {CL_STRING_REP_OF(CL_CID_NS), NULL},
    {CL_STRING_REP_OF(CL_CID_OM), NULL},
    {CL_STRING_REP_OF(CL_CID_POOL), NULL},
    {CL_STRING_REP_OF(CL_CID_CD), NULL},
    {CL_STRING_REP_OF(CL_CID_DM), NULL},
    {CL_STRING_REP_OF(CL_CID_OAMP_RT), NULL},
    {CL_STRING_REP_OF(CL_CID_PROV), NULL},
    {CL_STRING_REP_OF(CL_CID_UM), NULL},
    {CL_STRING_REP_OF(CL_CID_HANDLE), NULL},
    {CL_STRING_REP_OF(CL_CID_VERSION), NULL},
    {CL_STRING_REP_OF(CL_CID_XDR), NULL},
    {CL_STRING_REP_OF(CL_CID_IDL), NULL},
    {CL_STRING_REP_OF(CL_CID_HEAP), NULL},
    {CL_STRING_REP_OF(CL_CID_MEM), NULL},
    {CL_STRING_REP_OF(CL_CID_PARSER), NULL},
    {CL_STRING_REP_OF(CL_CID_BACKING_STORAGE), NULL},
    {CL_STRING_REP_OF(CL_CID_JOB), NULL},
    {CL_STRING_REP_OF(CL_CID_THREADPOOL), NULL},
    {CL_STRING_REP_OF(CL_CID_BITMAP), NULL},
    {CL_STRING_REP_OF(CL_CID_LEAKY_BUCKET), NULL},
    {CL_STRING_REP_OF(CL_CID_MSO), NULL},
    {CL_STRING_REP_OF(CL_CID_PM), NULL},
};

#endif
